<?php  function et_pb_b3_expanding_bar_setup() {

if ( class_exists('ET_Builder_Module')) {

class ET_Builder_Module_B3_Expanding_Bar extends ET_Builder_Module {
	function init() {
		$this->name             = esc_html__( 'Expanding Bar', 'et_builder' );
		$this->slug             = 'et_pb_b3_expanding_bar';
		$this->fb_support       = true;

		$this->whitelisted_fields = array(
			'b3_title',
			'b3_button_url',
			'b3_url_new_window',
			'b3_button_text',
			'b3_use_background_color_image',
			'b3_default_background_color',
			'b3_expanded_bar_background_color',
			'b3_default_background_image',
			'b3_expanded_bar_background_image',
			'b3_default_background_shadow_color',
			'b3_expanded_bar_background_shadow_color',
			'b3_background_layout',
			'b3_text_orientation',
			'content_new',
			'b3_width_unit',
			'b3_max_width_px',
			'b3_max_width_percent',
			'default_top_padding',
			'default_bottom_padding',
			'expanded_bar_top_padding',
			'expanded_bar_bottom_padding',
			'admin_label',
			'module_id',
			'module_class',
			'default_top_padding_tablet',
			'default_top_padding_phone',
			'default_top_padding_last_edited',
			'default_bottom_padding_tablet',
			'default_bottom_padding_phone',
			'default_bottom_padding_last_edited',
			'expanded_bar_top_padding_tablet',
			'expanded_bar_top_padding_phone',
			'expanded_bar_top_padding_last_edited',
			'expanded_bar_bottom_padding_tablet',
			'expanded_bar_bottom_padding_phone',
			'expanded_bar_bottom_padding_last_edited',
		);
		
		$this->fields_defaults = array(
			'b3_url_new_window'                    => array( 'off' ),
			'b3_use_background_color_image'      => array( 'color' ),
			'b3_default_background_color'          => array( et_builder_accent_color(), 'add_default_setting' ),
			'b3_expanded_bar_background_color'     => array( et_builder_accent_color(), 'add_default_setting' ),
			'b3_background_layout'    => array( 'dark' ),
			'b3_text_orientation'     => array( 'center' ),
			'b3_width_unit'            => array( 'on' ),
			'b3_max_width_px'       => array( '1080px', 'only_default_setting' ),
			'b3_max_width_percent'  => array( '80%', 'only_default_setting' ),
			'b3_default_background_shadow_color'          => array( 'rgba(22, 22, 22, 0.12)' ),
			'b3_expanded_bar_background_shadow_color'          => array( 'rgba(65, 80, 73, 0.3)' ),
		);
		
		$this->main_css_element = '%%order_class%%.et_pb_b3_promo';


		$this->options_toggles = array(
			'general'  => array(
				'toggles' => array(
					'main_content' => esc_html__( 'Text', 'et_builder' ),
					'link'         => esc_html__( 'Link', 'et_builder' ),
					'background_color_image'   => esc_html__( 'Background Color/Image', 'et_builder' ),
					'background_shadow'		   => esc_html__( 'Expanding Bar Shadow Color', 'et_builder' ),
				),
			),
			'advanced' => array(
				'toggles' => array(
					'text'  => array(
						'title'    => esc_html__( 'Text', 'et_builder' ),
						'priority' => 49,
					),
					'background_color_image'  => array(
						'title'    => esc_html__( 'Background Color/Image', 'et_builder' ),
						'priority' => 52,
					),
					'background_shadow'  => array(
						'title'    => esc_html__( 'Expanding Bar Shadow Color', 'et_builder' ),
						'priority' => 55,
					),
					'width' => array(
						'title'    => esc_html__( 'Sizing', 'et_builder' ),
						'priority' => 65,
					),
					'padding'  => array(
						'title'       => esc_html__( 'Spacing', 'et_builder' ),
						'priority'   => 70,
					),
				),
			),
		);

		$this->advanced_options = array(
			'fonts' => array(
				'b3_default_header' => array(
					'label'    => esc_html__( 'Default Header', 'et_builder' ),
					'css'      => array(
						'main' => "{$this->main_css_element} h2",
						'important' => 'all',
					),
				),
				'b3_default_body'   => array(
					'label'    => esc_html__( 'Default Body', 'et_builder' ),
					'css'      => array(
						'line_height' => "{$this->main_css_element} p",
						'main' => "{$this->main_css_element} p"
					),
				),
				'b3_expanded_bar_header' => array(
					'label'    => esc_html__( 'Expanding Bar Header', 'et_builder' ),
					'css'      => array(
						'main' => "body.poly_expanding_bar_highlight {$this->main_css_element} h2",
						'important' => 'all',
					),
				),
				'b3_expanded_bar_body'   => array(
					'label'    => esc_html__( 'Expanding Bar Body', 'et_builder' ),
					'css'      => array(
						'line_height' => "body.poly_expanding_bar_highlight {$this->main_css_element} p",
						'main' => "body.poly_expanding_bar_highlight {$this->main_css_element} p"
					),
				),
			),
			'border' => array(),
			'custom_margin_padding' => array(
				'css' => array(
				    'main' => "{$this->main_css_element}",
					'important' => 'all',
				),
			),
			'button' => array(
				'button_defaultbutton' => array(
					'label' => esc_html__( 'Default Button', 'et_builder' ),
					'css' => array(
						'main' => "{$this->main_css_element} .et_pb_b3_promo_button.et_pb_button",
					),
				),
				'button_expandingbarbutton' => array(
					'label' => esc_html__( 'Expanding Bar Button', 'et_builder' ),
					'css' => array(
						'main' => "{$this->main_css_element} .expanding_bar_highlight_button.et_pb_b3_promo_button.et_pb_button",
					),
				),
				
			),
			
		);
		
		
		$this->custom_css_options = array(
			'default_description' => array(
				'label'    => esc_html__( 'Default Description', 'et_builder' ),
				'selector' => '.et_pb_b3_promo_description',
			),
			'default_title' => array(
				'label'    => esc_html__( 'Default Title', 'et_builder' ),
				'selector' => '.et_pb_b3_promo_description h2',
			),
			'expanding_bar_description' => array(
				'label'    => esc_html__( 'Expanding Bar Description', 'et_builder' ),
				'selector' => '.et_pb_b3_promo_description.expanding_bar_highlight_description',
			),
			'expanding_bar_title' => array(
				'label'    => esc_html__( 'Expanding Bar Title', 'et_builder' ),
				'selector' => '.et_pb_b3_promo_description.expanding_bar_highlight_description h2',
			),
			'button_defaultbutton' => array(
				'label'    => esc_html__( 'Default Button', 'et_builder' ),
				'selector' => '.et_pb_b3_promo .et_pb_button.et_pb_b3_promo_button',
				'no_space_before_selector' => true,
			),
			'button_expandingbarbutton' => array(
				'label'    => esc_html__( 'Expanding Bar Button', 'et_builder' ),
				'selector' => '.et_pb_b3_promo .expanding_bar_highlight_button.et_pb_b3_promo_button.et_pb_button',
				'no_space_before_selector' => true,
			),
			
		);
		
	}

	function get_fields() {
		$fields = array(
			'b3_title' => array(
				'label'           => esc_html__( 'Title', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'basic_option',
				'description'     => esc_html__( 'Input your value to action title here.', 'et_builder' ),
				'toggle_slug'     => 'main_content',
			),
			'b3_button_url' => array(
				'label'           => esc_html__( 'Button URL', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'basic_option',
				'description'     => esc_html__( 'Input the destination URL for your CTA button.', 'et_builder' ),
				'toggle_slug'     => 'link',
			),
			'b3_url_new_window' => array(
				'label'           => esc_html__( 'Url Opens', 'et_builder' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'off' => esc_html__( 'In The Same Window', 'et_builder' ),
					'on'  => esc_html__( 'In The New Tab', 'et_builder' ),
				),
				'toggle_slug'     => 'link',
				'description'     => esc_html__( 'Here you can choose whether or not your link opens in a new window', 'et_builder' ),
			),
			'b3_button_text' => array(
				'label'           => esc_html__( 'Button Text', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'basic_option',
				'description'     => esc_html__( 'Input your desired button text, or leave blank for no button.', 'et_builder' ),
				'toggle_slug'     => 'main_content',
			),
			'b3_use_background_color_image' => array(
				'label'           => esc_html__( 'Use Background Color/Image', 'et_builder' ),
				'type'            => 'select',
				'option_category' => 'configuration',
				'options'         => array(
					'color'  => esc_html__( 'Color', 'et_builder' ),
					'image' => esc_html__( 'Image', 'et_builder' ),
				),
				'affects'           => array(
					'b3_default_background_color','b3_expanded_bar_background_color','b3_default_background_image','b3_expanded_bar_background_image',
				),
				'toggle_slug'     => 'background_color_image',
				'description'     => esc_html__( 'Here you can choose whether background color setting above should be used or not.', 'et_builder' ),
			),
			'b3_default_background_color' => array(
				'label'             => esc_html__( 'Default Background Color', 'et_builder' ),
				'type'              => 'color-alpha',
				'depends_show_if' => 'color',
				'toggle_slug'       => 'background_color_image',
				'description'       => esc_html__( 'Here you can define a custom background color for your CTA.', 'et_builder' ),
			),
			'b3_expanded_bar_background_color' => array(
				'label'             => esc_html__( 'Expanded Bar Background Color', 'et_builder' ),
				'type'              => 'color-alpha',
				'depends_show_if' => 'color',
				'toggle_slug'       => 'background_color_image',
				'description'       => esc_html__( 'Here you can define a custom background color for your CTA.', 'et_builder' ),
			),
			'b3_default_background_image' => array(
				'label'              => esc_html__( 'Default Background Image', 'et_builder' ),
				'type'               => 'upload',
				'option_category'    => 'configuration',
				'depends_show_if' => 'image',
				'upload_button_text' => esc_attr__( 'Upload an Image', 'et_builder' ),
				'choose_text'        => esc_attr__( 'Choose a Image', 'et_builder' ),
				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),
				'description'        => esc_html__( 'If defined, this slide image will appear to the left of your slide text. Upload an image, or leave blank for a text-only slide.', 'et_builder' ),
				'toggle_slug'        => 'background_color_image',
			),
			'b3_expanded_bar_background_image' => array(
				'label'              => esc_html__( 'Expanded Bar Background Image', 'et_builder' ),
				'type'               => 'upload',
				'option_category'    => 'configuration',
				'depends_show_if' => 'image',
				'upload_button_text' => esc_attr__( 'Upload an Image', 'et_builder' ),
				'choose_text'        => esc_attr__( 'Choose a Image', 'et_builder' ),
				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),
				'description'        => esc_html__( 'If defined, this slide image will appear to the left of your slide text. Upload an image, or leave blank for a text-only slide.', 'et_builder' ),
				'toggle_slug'        => 'background_color_image',
			),
			'b3_default_background_shadow_color' => array(
				'label'             => esc_html__( ' Default Bar Box Shadow Color', 'et_builder' ),
				'type'              => 'color-alpha',
				'toggle_slug'       => 'background_shadow',
			),
			'b3_expanded_bar_background_shadow_color' => array(
				'label'             => esc_html__( 'Expanded Bar Box Shadow Color', 'et_builder' ),
				'type'              => 'color-alpha',
				'toggle_slug'       => 'background_shadow',
			),
			'b3_background_layout' => array(
				'label'           => esc_html__( 'Text Color', 'et_builder' ),
				'type'            => 'select',
				'option_category' => 'color_option',
				'options'         => array(
					'dark'  => esc_html__( 'Light', 'et_builder' ),
					'light' => esc_html__( 'Dark', 'et_builder' ),
				),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'text',
				'description'     => esc_html__( 'Here you can choose whether your text should be light or dark. If you are working with a dark background, then your text should be light. If your background is light, then your text should be set to dark.', 'et_builder' ),
			),
			'b3_text_orientation' => array(
				'label'             => esc_html__( 'Text Orientation', 'et_builder' ),
				'type'              => 'select',
				'option_category'   => 'layout',
				'options' => array(
					'center' => esc_html__( 'Center', 'et_builder' ), 
					'left'   => esc_html__( 'Left', 'et_builder' ),
					'right'  => esc_html__( 'Right', 'et_builder' ),
					'justified'  => esc_html__( 'Justified', 'et_builder' ),
				),
				'tab_slug'          => 'advanced',
				'toggle_slug'       => 'text',
				'description'       => esc_html__( 'This will adjust the alignment of the module text.', 'et_builder' ),
			),
			'content_new' => array(
				'label'           => esc_html__( 'Content', 'et_builder' ),
				'type'            => 'tiny_mce',
				'option_category' => 'basic_option',
				'description'     => esc_html__( 'Input the main text content for your module here.', 'et_builder' ),
				'toggle_slug'     => 'main_content',
			),
			'b3_width_unit' => array(
				'label'             => esc_html__( 'Unit', 'et_builder' ),
				'type'              => 'yes_no_button',
				'option_category'   => 'layout',
				'options'           => array(
					'on'  => esc_html__( 'px', 'et_builder' ),
					'off' => '%',
				),
				'default'           => 'on',
				'button_options'    => array(
					'button_type' => 'equal',
				),
				'affects'           => array(
					'b3_max_width_px',
					'b3_max_width_percent',
				),
				'toggle_slug'       => 'main_content',
			),
			'b3_max_width_percent' => array(
				'label'           => esc_html__( 'Max Width', 'et_builder' ),
				'type'            => 'range',
				'option_category' => 'layout',
				'depends_show_if' => 'off',
				'validate_unit'   => true,
				'fixed_unit'      => '%',
				'range_settings'  => array(
					'min'  => 0,
					'max'  => 100,
					'step' => 1,
				),
				'toggle_slug'     => 'main_content',
			),
			'b3_max_width_px' => array(
				'label'           => esc_html__( 'Max Width', 'et_builder' ),
				'type'            => 'range',
				'option_category' => 'layout',
				'depends_show_if_not' => 'off',
				'validate_unit'       => true,
				'fixed_unit'          => 'px',
				'range_settings'      => array(
					'min'  => 500,
					'max'  => 2600,
					'step' => 1,
				),
				'toggle_slug'     => 'main_content',
			),
			'disabled_on' => array(
				'label'           => esc_html__( 'Disable on', 'et_builder' ),
				'type'            => 'multiple_checkboxes',
				'options'         => array(
					'phone'   => esc_html__( 'Phone', 'et_builder' ),
					'tablet'  => esc_html__( 'Tablet', 'et_builder' ),
					'desktop' => esc_html__( 'Desktop', 'et_builder' ),
				),
				'additional_att'  => 'disable_on',
				'option_category' => 'configuration',
				'description'     => esc_html__( 'This will disable the module on selected devices', 'et_builder' ),
				'tab_slug'        => 'custom_css',
				'toggle_slug'     => 'visibility',
			),
			'admin_label' => array(
				'label'       => esc_html__( 'Admin Label', 'et_builder' ),
				'type'        => 'text',
				'description' => esc_html__( 'This will change the label of the module in the builder for easy identification.', 'et_builder' ),
				'toggle_slug' => 'admin_label',
			),
			'module_id' => array(
				'label'           => esc_html__( 'CSS ID', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'tab_slug'        => 'custom_css',
				'toggle_slug'     => 'classes',
				'option_class'    => 'et_pb_custom_css_regular',
			),
			'module_class' => array(
				'label'           => esc_html__( 'CSS Class', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'configuration',
				'tab_slug'        => 'custom_css',
				'toggle_slug'     => 'classes',
				'option_class'    => 'et_pb_custom_css_regular',
			),
			'default_top_padding' => array(
				'label'           => esc_html__( 'Default Top Padding', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'layout',
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'padding',
				'mobile_options'  => true,
				'validate_unit'   => true,
			),
			'default_bottom_padding' => array(
				'label'           => esc_html__( 'Default Bottom Padding', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'layout',
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'padding',
				'mobile_options'  => true,
				'validate_unit'   => true,
			),
			'expanded_bar_top_padding' => array(
				'label'           => esc_html__( 'Expanded Bar Top Padding', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'layout',
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'padding',
				'mobile_options'  => true,
				'validate_unit'   => true,
			),
			'expanded_bar_bottom_padding' => array(
				'label'           => esc_html__( 'Expanded Bar Bottom Padding', 'et_builder' ),
				'type'            => 'text',
				'option_category' => 'layout',
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'padding',
				'mobile_options'  => true,
				'validate_unit'   => true,
			),
			'default_top_padding_tablet' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'default_top_padding_phone' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'default_top_padding_last_edited' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'default_bottom_padding_tablet' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'default_bottom_padding_phone' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'default_bottom_padding_last_edited' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'expanded_bar_top_padding_tablet' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'expanded_bar_top_padding_phone' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'expanded_bar_top_padding_last_edited' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'expanded_bar_bottom_padding_tablet' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'expanded_bar_bottom_padding_phone' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
			'expanded_bar_bottom_padding_last_edited' => array(
				'type'        => 'skip',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
			),
		);


		return $fields;
	}

	function shortcode_callback( $atts, $content = null, $function_name ) {

		$button_custom_1              = $this->shortcode_atts['custom_button_defaultbutton'];
		$button_custom_2              = $this->shortcode_atts['custom_button_expandingbarbutton'];
		$b3_title                     = $this->shortcode_atts['b3_title'];
		$b3_button_url          	  = $this->shortcode_atts['b3_button_url'];
		$b3_url_new_window       	  = $this->shortcode_atts['b3_url_new_window'];
		$b3_button_text          	  = $this->shortcode_atts['b3_button_text'];
		
		$b3_use_background_color_image      = $this->shortcode_atts['b3_use_background_color_image'];
		$b3_default_background_color  = $this->shortcode_atts['b3_default_background_color'];
		$b3_expanded_bar_background_color        = $this->shortcode_atts['b3_expanded_bar_background_color'];
		$b3_default_background_image  = $this->shortcode_atts['b3_default_background_image'];
		$b3_expanded_bar_background_image        = $this->shortcode_atts['b3_expanded_bar_background_image'];
		
		
		$b3_background_layout         = $this->shortcode_atts['b3_background_layout'];
		$b3_text_orientation          = $this->shortcode_atts['b3_text_orientation'];
		$custom_icon         		  = $this->shortcode_atts['button_icon'];
		$button_custom        		  = $this->shortcode_atts['custom_button'];
		$module_id            		  = $this->shortcode_atts['module_id'];
		$module_class          		  = $this->shortcode_atts['module_class'];
		$b3_width_unit          		  = $this->shortcode_atts['b3_width_unit'];
		$b3_max_width_px          		  = $this->shortcode_atts['b3_max_width_px'];
		$b3_max_width_percent          		  = $this->shortcode_atts['b3_max_width_percent'];
		
		$b3_default_background_shadow_color        = $this->shortcode_atts['b3_default_background_shadow_color'];
		$b3_expanded_bar_background_shadow_color        = $this->shortcode_atts['b3_expanded_bar_background_shadow_color'];
		
		
		$default_top_padding             = $this->shortcode_atts['default_top_padding'];
		$default_bottom_padding          = $this->shortcode_atts['default_bottom_padding'];
		$default_top_padding_tablet      = $this->shortcode_atts['default_top_padding_tablet'];
		$default_top_padding_phone       = $this->shortcode_atts['default_top_padding_phone'];
		$default_top_padding_last_edited = $this->shortcode_atts['default_top_padding_last_edited'];
		$default_bottom_padding_tablet   = $this->shortcode_atts['default_bottom_padding_tablet'];
		$default_bottom_padding_phone    = $this->shortcode_atts['default_bottom_padding_phone'];
		$default_bottom_padding_last_edited = $this->shortcode_atts['default_bottom_padding_last_edited'];
		
		$expanded_bar_top_padding             = $this->shortcode_atts['expanded_bar_top_padding'];
		$expanded_bar_bottom_padding          = $this->shortcode_atts['expanded_bar_bottom_padding'];
		$expanded_bar_top_padding_tablet      = $this->shortcode_atts['expanded_bar_top_padding_tablet'];
		$expanded_bar_top_padding_phone       = $this->shortcode_atts['expanded_bar_top_padding_phone'];
		$expanded_bar_top_padding_last_edited = $this->shortcode_atts['expanded_bar_top_padding_last_edited'];
		$expanded_bar_bottom_padding_tablet   = $this->shortcode_atts['expanded_bar_bottom_padding_tablet'];
		$expanded_bar_bottom_padding_phone    = $this->shortcode_atts['expanded_bar_bottom_padding_phone'];
		$expanded_bar_bottom_padding_last_edited = $this->shortcode_atts['expanded_bar_bottom_padding_last_edited'];
		
		$module_class = ET_Builder_Element::add_module_order_class( $module_class, $function_name );
		$rand =  "expanding_bar_".rand(10,500);
		if ( is_rtl() && 'left' === $b3_text_orientation ) {
			$b3_text_orientation = 'right';
		}
		
		
		if ( '' !== $default_top_padding || '' !== $default_top_padding_tablet || '' !== $default_top_padding_phone ) {
			$default_top_padding_responsive_active = et_pb_get_responsive_status( $default_top_padding_last_edited );

			$default_padding_values = array(
				'desktop' => $default_top_padding,
				'tablet'  => $default_top_padding_responsive_active ? $default_top_padding_tablet : '',
				'phone'   => $default_top_padding_responsive_active ? $default_top_padding_phone : '',
			);

			et_pb_generate_responsive_css( $default_padding_values, '%%order_class%%.et_pb_b3_promo', 'padding-top', $function_name, ' !important; ' );
		}

		if ( '' !== $default_bottom_padding || '' !== $default_bottom_padding_tablet || '' !== $default_bottom_padding_phone ) {
			$default_bottom_padding_responsive_active = et_pb_get_responsive_status( $default_bottom_padding_last_edited );

			$default_padding_values = array(
				'desktop' => $default_bottom_padding,
				'tablet'  => $default_bottom_padding_responsive_active ? $default_bottom_padding_tablet : '',
				'phone'   => $default_bottom_padding_responsive_active ? $default_bottom_padding_phone : '',
			);

			et_pb_generate_responsive_css( $default_padding_values, '%%order_class%%.et_pb_b3_promo', 'padding-bottom', $function_name, ' !important; ' );
		}

		if ( '' !== $default_bottom_padding || '' !== $default_top_padding ) {
			ET_Builder_Module::set_style( $function_name, array(
				'selector'    => '%%order_class%%.et_pb_b3_promo',
				'declaration' => 'transition: all 1.8s ease;-moz-transition: all 1.8s ease; -webkit-transition: all 1.8s ease; ',
			) );
		}
		
		if ( '' !== $expanded_bar_top_padding || '' !== $expanded_bar_bottom_padding ) {
			ET_Builder_Module::set_style( $function_name, array(
				'selector'    => 'body.poly_expanding_bar_highlight %%order_class%%.et_pb_b3_promo',
				'declaration' => 'transition: all 1.8s ease  !important;-moz-transition: all 1.8s ease  !important; -webkit-transition: all 1.8s ease  !important; ',
			) );
		}
		
		if ( '' !== $expanded_bar_top_padding || '' !== $expanded_bar_top_padding_tablet || '' !== $expanded_bar_top_padding_phone ) {
			$expanded_bar_top_padding_responsive_active = et_pb_get_responsive_status( $expanded_bar_top_padding_last_edited );

			$expanded_bar_padding_values = array(
				'desktop' => $expanded_bar_top_padding,
				'tablet'  => $expanded_bar_top_padding_responsive_active ? $expanded_bar_top_padding_tablet : '',
				'phone'   => $expanded_bar_top_padding_responsive_active ? $expanded_bar_top_padding_phone : '',
			);

			et_pb_generate_responsive_css( $expanded_bar_padding_values, 'body.poly_expanding_bar_highlight %%order_class%%.et_pb_b3_promo', 'padding-top', $function_name, ' !important; ' );
		}

		if ( '' !== $expanded_bar_bottom_padding || '' !== $expanded_bar_bottom_padding_tablet || '' !== $expanded_bar_bottom_padding_phone ) {
			$expanded_bar_bottom_padding_responsive_active = et_pb_get_responsive_status( $expanded_bar_bottom_padding_last_edited );

			$expanded_bar_padding_values = array(
				'desktop' => $expanded_bar_bottom_padding,
				'tablet'  => $expanded_bar_bottom_padding_responsive_active ? $expanded_bar_bottom_padding_tablet : '',
				'phone'   => $expanded_bar_bottom_padding_responsive_active ? $expanded_bar_bottom_padding_phone : '',
			);

			et_pb_generate_responsive_css( $expanded_bar_padding_values, 'body.poly_expanding_bar_highlight %%order_class%%.et_pb_b3_promo', 'padding-bottom', $function_name, ' !important; ' );
		}
		
		if ( '' !== $max_width ) { 
				ET_Builder_Element::set_style( $function_name, array(
					'selector'    => '.et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth',
					'declaration' => sprintf(
						'max-width:%1$s !important;',
						'on' === $b3_width_unit ? esc_attr( $b3_max_width_px ) : esc_attr( $b3_max_width_percent )
					),
				) );
		}
		
		if ( '' !== $b3_default_background_shadow_color ) {
				ET_Builder_Element::set_style( $function_name, array(
					'selector'    => '.et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth',
					'declaration' => sprintf(
						'box-shadow: 0 20px 150px %1$s;
					  	-webkit-box-shadow: 0 20px 150px %1$s;
					 	-moz-box-shadow: 0 20px 150px %1$s;
					    -o-box-shadow: 0 20px 150px %1$s;',
						esc_html( $b3_default_background_shadow_color )
					),
				) );
			}
			
			if ( '' !== $b3_expanded_bar_background_shadow_color ) {
				ET_Builder_Element::set_style( $function_name, array(
					'selector'    => 'body.poly_expanding_bar_highlight .et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth',
					'declaration' => sprintf(
						'box-shadow: 0 40px 150px %1$s;
						  -webkit-box-shadow: 0 40px 150px %1$s;
						  -moz-box-shadow: 0 40px 150px %1$s;
						  -o-box-shadow: 0 40px 150px %1$s; ',
						esc_html( $b3_expanded_bar_background_shadow_color )
					),
				) );
			}
			
			
		if ( $b3_use_background_color_image ==  'color' ){
		
			$b3_default_background_color_css = '';
			$b3_expanded_bar_background_color_css = '';
			if ( '' !== $b3_default_background_color ) {
				/*ET_Builder_Element::set_style( $function_name, array(
					'selector'    => '.et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth',
					'declaration' => sprintf(
						'background-color: %1$s !important;',
						esc_html( $b3_default_background_color )
					),
				) );*/
				$b3_default_background_color_css .= '.et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth{background-color: '.esc_html( $b3_default_background_color ).' !important;}';
			}
			
			if ( '' !== $b3_expanded_bar_background_color ) {
				/*ET_Builder_Element::set_style( $function_name, array(
					'selector'    => 'body.expanding_bar_highlight.'.$rand.' .et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth',
					'declaration' => sprintf(
						'background-color: %1$s !important;',
						esc_html( $b3_expanded_bar_background_color )
					),
				) );*/
				$b3_expanded_bar_background_color_css .= 'body.expanding_bar_highlight.'.$rand.' .et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth{background-color: '.esc_html( $b3_expanded_bar_background_color ).' !important;}';
			}
			
			

		}
		
		
		if ( $b3_use_background_color_image ==  'image' ){
			$b3_default_background_image_css = '';
			$b3_expanded_bar_background_image_css = '';
			if ( '' !== $b3_default_background_image ) {
				/*ET_Builder_Element::set_style( $function_name, array(
					'selector'    => '.et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth',
					'declaration' => sprintf(
						'background-image: url("%1$s") !important;',
						esc_html( $b3_default_background_image )
					),
				) );*/
				$b3_default_background_image_css .= '.et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth{background-image: url('.esc_html( $b3_default_background_image ).') !important;background-position: initial;}';
				
			}
			
			if ( '' !== $b3_expanded_bar_background_image ) {
				/*ET_Builder_Element::set_style( $function_name, array(
					'selector'    => 'body.expanding_bar_highlight.'.$rand.' .et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth',
					'declaration' => sprintf(
						'background-image: url("%1$s") !important;',
						esc_html( $b3_expanded_bar_background_image )
					),
				) );*/
				$b3_expanded_bar_background_image_css .= 'body.expanding_bar_highlight.'.$rand.' .et_pb_expanding_bar_section.'.$rand.' .et_pb_row.et_pb_row_fullwidth{background-image:url( '.esc_html( $b3_expanded_bar_background_image ).') !important;background-position: initial;}';
			}

		}
		
		
		$class = " et_pb_module et_pb_bg_layout_{$b3_background_layout} et_pb_text_align_{$b3_text_orientation}";

		$b3_button_url = trim( $b3_button_url );

		$output = sprintf(
			'<div%5$s class="et_pb_expanding_bar_container et_pb_b3_promo '.$rand.' %4$s%6$s%7$s">
				<div class="et_pb_b3_promo_description">
					%1$s
					%2$s
				</div>
				%3$s
			</div>',
			( '' !== $b3_title ? '<h2>' . esc_html( $b3_title ) . '</h2>' : '' ),
			$this->shortcode_content,
			(
				'' !== $b3_button_url && '' !== $b3_button_text
					? sprintf( '<a class="et_pb_b3_promo_button et_pb_button%5$s" href="%1$s"%3$s%4$s>%2$s</a>',
						esc_url( $b3_button_url ),
						esc_html( $b3_button_text ),
						( 'on' === $b3_url_new_window ? ' target="_blank"' : '' ),
						'' !== $custom_icon && 'on' === $button_custom ? sprintf(
							' data-icon="%1$s"',
							esc_attr( et_pb_process_font_icon( $custom_icon ) )
						) : '',
						'' !== $custom_icon && 'on' === $button_custom ? ' et_pb_custom_button_icon' : ''
					)
					: ''
			),
			esc_attr( $class ),
			( '' !== $module_id ? sprintf( ' id="%1$s"', esc_attr( $module_id ) ) : '' ),
			( '' !== $module_class ? sprintf( ' %1$s', esc_attr( $module_class ) ) : '' ),
			( 'on' !== $b3_use_background_color ? ' et_pb_no_bg' : '' )
		);
		
		$output .= "<script>
							jQuery(document).ready(function(){
								jQuery('.et_pb_b3_promo.".$rand."').parent().parent().parent().addClass('et_pb_expanding_bar_section ".$rand."');
								jQuery('.et_pb_b3_promo.".$rand."').parent().parent().addClass('et_pb_row_fullwidth');	
								jQuery('body').addClass('expanding_bar_highlight');
								jQuery('.et_pb_expanding_bar_section.".$rand."').waypoint(function() {
									jQuery('body').toggleClass('".$rand."');
									jQuery('body').toggleClass('poly_expanding_bar_highlight');
									jQuery('.et_pb_expanding_bar_section.".$rand." .et_pb_b3_promo_button').toggleClass('expanding_bar_highlight_button');
									jQuery('.et_pb_expanding_bar_section.".$rand." .et_pb_b3_promo_description').toggleClass('expanding_bar_highlight_description');
								}, {offset: '50%'});
							});
					 </script>
					 <style>
					   .expanding_bar_highlight.".$rand." .et_pb_expanding_bar_section.".$rand." .et_pb_row.et_pb_row_fullwidth{ 
						  width: 100% !important;
						  max-width:100% !important;}
						  ".$b3_default_background_color_css.$b3_expanded_bar_background_color_css.$b3_default_background_image_css.$b3_expanded_bar_background_image_css." 
					 </style>";
					 
		return $output;
		
	}
}
new ET_Builder_Module_B3_Expanding_Bar;
}

    $b3_expanding_bar = new ET_Builder_Module_B3_Expanding_Bar();
	add_shortcode( 'b3_expanding_bar', array($b3_expanding_bar, 'shortcode_callback') );
	
}
add_action('et_builder_ready', 'et_pb_b3_expanding_bar_setup');
?>