<?php 
require_once( get_stylesheet_directory() . '/lib/marvel-license.php' );
// Load the API Key library if it is not already loaded. Must be placed in the root plugin file.
if (  class_exists( 'Marvel_License_Theme' ) ) {
    /**
     * @param string $file             Must be __FILE__ from the root plugin file, or theme functions file.
     * @param string $software_title   Must be exactly the same as the Software Title in the product.
     * @param string $software_version This product's current software version.
     * @param string $plugin_or_theme  'plugin' or 'theme'
     * @param string $api_url          The URL to the site that is running the API Manager. Example: https://www.toddlahman.com/
     *
     * @return \AM_License_Submenu|null
     */
    Marvel_License_Theme::instance( __FILE__, 'Marvel', '1.2.3', 'theme', 'https://b3multimedia.ie/' );
}
function elegant_enqueue_css() { 

wp_enqueue_style( 'parent-style', get_template_directory_uri() . '/style.css' ); 
wp_enqueue_style( 'b3_expanding_bar_module-style', get_stylesheet_directory_uri() . '/css/b3_expanding_bar_module.css' ); 
}

add_action( 'wp_enqueue_scripts', 'elegant_enqueue_css' );

include('editor/login-editor.php');

// Enqueue Modal Popup
add_action( 'wp_enqueue_scripts', 'marvel_scripts' );

function marvel_scripts() {
    wp_enqueue_script( 'marvel-particleground', get_stylesheet_directory_uri() . '/js/particles.min.js', array( 'jquery' ), '', true );
	wp_enqueue_script( 'marvel-custom', get_stylesheet_directory_uri() . '/js/marvel-custom.js', array( 'jquery' ), '', true );
	 
	$divi_marvel_dot_color = !empty(et_get_option('divi_marvel_dot_color')) ? et_get_option('divi_marvel_dot_color') : '#f3b200'; 
	$divi_marvel_line_color = !empty(et_get_option('divi_marvel_line_color')) ? et_get_option('divi_marvel_line_color') : '#f3b200'; 
	$divi_marvel_line_width = !empty(et_get_option('divi_marvel_line_width')) ? et_get_option('divi_marvel_line_width') : '1'; 
	$divi_marvel_bulb_size = !empty(et_get_option('divi_marvel_bulb_size')) ? et_get_option('divi_marvel_bulb_size') : '5';
	$divi_marvel_speed = !empty(et_get_option('divi_marvel_speed')) ? et_get_option('divi_marvel_speed') : '2';
	$divi_marvel_interactivity = !empty(et_get_option('divi_marvel_interactivity')) ? et_get_option('divi_marvel_interactivity') : 'off';
	
	$divi_marvel_read_more_button_text = !empty(et_get_option('divi_marvel_read_more_button_text')) ? et_get_option('divi_marvel_read_more_button_text') : 'Read More';
	
	$divimobilelogo = ( $divi_mobile_logo = et_get_option( 'divi_logo' ) ) && '' != $divi_mobile_logo
					? $divi_mobile_logo
					: get_stylesheet_directory_uri() . '/images/logo.png';

	$divi_marvel_switch_to_mobile_menu = !empty(et_get_option('divi_marvel_switch_to_mobile_menu')) ? et_get_option('divi_marvel_switch_to_mobile_menu') : '980px';
    wp_localize_script( 'marvel-custom', 'marvelparticleground', array( 'divi_marvel_dot_color' => $divi_marvel_dot_color,'divi_marvel_line_color'=> $divi_marvel_line_color,'divi_marvel_line_width'=> $divi_marvel_line_width,'divi_marvel_bulb_size'=> $divi_marvel_bulb_size,'divi_marvel_speed'=> $divi_marvel_speed,'divi_marvel_interactivity'=> $divi_marvel_interactivity,'divi_marvel_switch_to_mobile_menu'=> $divi_marvel_switch_to_mobile_menu,'divi_marvel_read_more_button_text'=> $divi_marvel_read_more_button_text  ) );
			
	$divi_trigger_caldera_popup_form = et_get_option('divi_trigger_caldera_popup_form','on'); 	
	if ( $divi_trigger_caldera_popup_form == 'on'){		
	
		$divi_trigger_select_plugin = et_get_option('divi_trigger_select_plugin','caldera'); 	
					
		$divi_top_menu_caldera_popup_form = et_get_option('divi_top_menu_caldera_popup_form','');
		$divi_top_menu_contact_form7 = et_get_option('divi_top_menu_contact_form7'); 	
		$divi_top_menu_garvity_form = et_get_option('divi_top_menu_garvity_form'); 
		
		if( $divi_trigger_select_plugin == 'caldera'){
			
			wp_enqueue_script( 'marvel_popup', get_stylesheet_directory_uri() . '/js/marvel_popup.js', array( 'jquery' ), '', true );
			wp_localize_script( 'marvel_popup', 'divi_caldera_popup_form', array( 'divi_top_menu_caldera_popup_form' => $divi_top_menu_caldera_popup_form) );
		
		}
		if( $divi_trigger_select_plugin == 'contact_form7' || $divi_trigger_select_plugin == 'garvity_form'){
		
			wp_enqueue_script( 'marvel_popup_js', get_stylesheet_directory_uri() . '/js/popup-modal.js', array( 'jquery' ), '', true );
			wp_enqueue_style( 'marvel_popup_style', get_stylesheet_directory_uri() . '/css/popup_css.css' ); 
			
		}
	}
	
	wp_enqueue_script( 'marvel_theme_style', get_stylesheet_directory_uri() . '/js/marvel_theme_style.js', array('jquery'), NULL, TRUE );

	$divi_marvel_theme_color = et_get_option( 'divi_marvel_custom_elements_color', '#f3b200' );
	wp_localize_script( 'marvel_theme_style', 'marvelthemestyle', array( 'divi_marvel_theme_color' => $divi_marvel_theme_color ) );

}

add_action('admin_enqueue_scripts', 'marvel_enqueue_admin', 9999);

function marvel_enqueue_admin() {
	wp_enqueue_style('marvel-custom-admin', get_stylesheet_directory_uri().'/css/admin_marvel_custom.css');
	wp_enqueue_script( 'marvel-admin-js', get_stylesheet_directory_uri() . '/js/marvel-admin.js', array( 'jquery' ), '', true );
	wp_localize_script( 'marvel-admin-js', 'et_divi_100_js_params', apply_filters( 'et_divi_100_js_params', array(
				'preview_dir_url' => esc_url( get_stylesheet_directory_uri(). '/assets/preview/' ),
				'help_label'      => esc_html__( 'Help' ),
	) ) );
}
// Add Customizer Settings
include get_stylesheet_directory() . '/b3_customizer.php';
include get_stylesheet_directory() . '/marvel_theme_option.php';

/* 2 column blog images */
function gallery_size_h($height) {
return '600';
}
add_filter( 'et_pb_blog_image_height', 'gallery_size_h' );
function gallery_size_w($width) {
return '300';
}
add_filter( 'et_pb_blog_image_width', 'gallery_size_w' );
/**
 * This file represents an example of the code that themes would use to register
 * the required plugins.
 *
 * It is expected that theme authors would copy and paste this code into their
 * functions.php file, and amend to suit.
 *
 * @see http://tgmpluginactivation.com/configuration/ for detailed documentation.
 *
 * @package    TGM-Plugin-Activation
 * @subpackage Example
 * @version    2.6.1 for child theme Bruno
 * @author     Thomas Griffin, Gary Jones, Juliette Reinders Folmer
 * @copyright  Copyright (c) 2011, Thomas Griffin
 * @license    http://opensource.org/licenses/gpl-2.0.php GPL v2 or later
 * @link       https://github.com/TGMPA/TGM-Plugin-Activation
 */

/**
 * Include the TGM_Plugin_Activation class.
 *
 * Depending on your implementation, you may want to change the include call:
 *
 * Parent Theme:
 * require_once get_template_directory() . '/path/to/class-tgm-plugin-activation.php';
 *
 * Child Theme:
 * require_once get_stylesheet_directory() . '/path/to/class-tgm-plugin-activation.php';
 *
 * Plugin:
 * require_once dirname( __FILE__ ) . '/path/to/class-tgm-plugin-activation.php';
 */
require_once get_stylesheet_directory() . '/class-tgm-plugin-activation.php';

add_action( 'tgmpa_register', 'marvel_register_required_plugins' );

/**
 * Register the required plugins for this theme.
 *
 * In this example, we register five plugins:
 * - one included with the TGMPA library
 * - two from an external source, one from an arbitrary source, one from a GitHub repository
 * - two from the .org repo, where one demonstrates the use of the `is_callable` argument
 *
 * The variables passed to the `tgmpa()` function should be:
 * - an array of plugin arrays;
 * - optionally a configuration array.
 * If you are not changing anything in the configuration array, you can remove the array and remove the
 * variable from the function call: `tgmpa( $plugins );`.
 * In that case, the TGMPA default settings will be used.
 *
 * This function is hooked into `tgmpa_register`, which is fired on the WP `init` action on priority 10.
 */
function marvel_register_required_plugins() {
    /*
     * Array of plugin arrays. Required keys are name and slug.
     * If the source is NOT from the .org repo, then source is also required.
     */
    $plugins = array(

        // This is an example of how to include a plugin from the WordPress Plugin Repository.
        array(
            'name'      => 'Caldera Forms - Drag and drop responsive WordPress form builder',
            'slug'      => 'caldera-forms',
            'required'  => true,
        ),
        array(
            'name'      => 'One Click Demo Import',
            'slug'      => 'one-click-demo-import',
            'required'  => true,
        ),
        array(
            'name'      => 'WooCommerce',
            'slug'      => 'woocommerce',
            'required'  => false,
        ),
		 array(
            'name'      => 'Recent Posts Widget With Thumbnails',
            'slug'      => 'recent-posts-widget-with-thumbnails',
            'required'  => false,
        )
		
    );

    /*
     * Array of configuration settings. Amend each line as needed.
     *
     * TGMPA will start providing localized text strings soon. If you already have translations of our standard
     * strings available, please help us make TGMPA even better by giving us access to these translations or by
     * sending in a pull-request with .po file(s) with the translations.
     *
     * Only uncomment the strings in the config array if you want to customize the strings.
     */
    $config = array(
        'id'           => 'marvel',                 // Unique ID for hashing notices for multiple instances of TGMPA.
        'default_path' => '',                      // Default absolute path to bundled plugins.
        'menu'         => 'tgmpa-install-plugins', // Menu slug.
        'parent_slug'  => 'themes.php',            // Parent menu slug.
        'capability'   => 'edit_theme_options',    // Capability needed to view plugin install page, should be a capability associated with the parent menu used.
        'has_notices'  => true,                    // Show admin notices or not.
        'dismissable'  => true,                    // If false, a user cannot dismiss the nag message.
        'dismiss_msg'  => '',                      // If 'dismissable' is false, this message will be output at top of nag.
        'is_automatic' => true,                   // Automatically activate plugins after installation or not.
        'message'      => '',                      // Message to output right before the plugins table.

    );

    tgmpa( $plugins, $config );
}
/*Import Bruno Child Theme Data and Settings*/

function ocdi_before_widgets_import( $selected_import ) {
   delete_option('sidebars_widgets');
}
add_action( 'pt-ocdi/before_widgets_import', 'ocdi_before_widgets_import' );

function ocdi_import_files() {
    return array(
        array(
            'import_file_name'           => 'Demo Import',
            'import_file_url'            => 'https://marvel.b3multimedia.ie/imports/marvel.xml',
            'import_widget_file_url'     => 'https://marvel.b3multimedia.ie/imports/marvel.wie',
            'import_customizer_file_url' => 'https://marvel.b3multimedia.ie/imports/marvel.dat',
            'import_notice'              => __( 'Please be patient. Importing demo can take even several minutes, depending on server speed.' ),
        ),
    );
}
add_filter( 'pt-ocdi/import_files', 'ocdi_import_files' );
function marvel_ocdi_importer_options( $options ) {
    $options['aggressive_url_search'] = true;
    return $options;
}
add_filter( 'pt-ocdi/importer_options', 'marvel_ocdi_importer_options' );
//add_action( 'pt-ocdi/enable_wp_customize_save_hooks', '__return_true' );
/*Assign Menu*/
function ocdi_after_import_setup() {
    //Menus to assign after import.
    $main_menu  = get_term_by( 'name', 'Main Menu', 'nav_menu' );
    $top_menu = get_term_by( 'name' , 'Top Menu', 'nav_menu' );
    set_theme_mod( 'nav_menu_locations', array(
        'primary-menu'      =>  $main_menu->term_id,
        'secondary-menu'    =>  $top_menu->term_id, 
        ));
        
/*Set Front Page from Reading Options*/
    $front_page = get_page_by_title( 'Construction' );
    if(isset( $front_page ) && $front_page->ID) {
        update_option( 'show_on_front','page' );
        update_option( 'page_on_front', $front_page->ID );
    }
	$page_cart = get_page_by_title( 'Cart' );
	$page_checkout = get_page_by_title( 'Checkout' );
	update_option( 'woocommerce_cart_page_id', $page_cart->ID );
	update_option( 'woocommerce_checkout_page_id', $page_checkout->ID );
	
	global $wpdb;
    $oldurl = "https://marvel.b3multimedia.ie";
    $newurl = site_url();
    $results = array();
    $queries = array(
        'content' =>        "UPDATE $wpdb->posts SET post_content = replace(post_content, %s, %s)",
        'excerpts' =>        "UPDATE $wpdb->posts SET post_excerpt = replace(post_excerpt, %s, %s)",
        'attachments' =>    "UPDATE $wpdb->posts SET guid = replace(guid, %s, %s) WHERE post_type = 'attachment'",
        //'links' =>            "UPDATE $wpdb->links SET link_url = replace(link_url, %s, %s)",
        //'custom' =>            array("UPDATE $wpdb->postmeta SET meta_value = replace(meta_value, %s, %s)",  __('Custom Fields') ),
        'guids' =>            "UPDATE $wpdb->posts SET guid = replace(guid, %s, %s)",
    );
    foreach ( $queries as $query_exe ){
        $result = $wpdb->query( $wpdb->prepare( $query_exe, $oldurl, $newurl) );
    }
}
add_action( 'pt-ocdi/after_import', 'ocdi_after_import_setup' );

wp_delete_post(1);


add_action( 'wp_footer', 'marvel_footer' );

function marvel_footer(){

wp_enqueue_style( 'marvel_custom_button', get_stylesheet_directory_uri() . '/css/marvel_custom.css', array(),true);
$divi_marvel_button_size = et_get_option('divi_marvel_button_size','Regular');

$dh_background_color = et_get_option('divi_dh_button_contact_menu_background_color','#f3b200');
$dh_text_color = et_get_option('divi_dh_button_contact_menu_text_color','#ffffff');
$dh_border_color = et_get_option('divi_dh_button_contact_menu_border_color','#f3b200');
$dh_hover_background_color = et_get_option('divi_dh_button_contact_menu_hover_background_color','#f3b200');
$dh_hover_text_color = et_get_option('divi_dh_button_contact_menu_hover_text_color','#ffffff');
$dh_hover_border_color = et_get_option('divi_dh_button_contact_menu_hover_border_color','#f3b200');
$dh_border_radius = et_get_option('divi_dh_button_contact_menu_border_radius','1px');
//$dh_padding = et_get_option('divi_dh_button_contact_menu_padding','0px');


$fh_background_color = et_get_option('divi_fh_button_contact_menu_background_color','#f3b200');
$fh_text_color = et_get_option('divi_fh_button_contact_menu_text_color','#ffffff');
$fh_border_color = et_get_option('divi_fh_button_contact_menu_border_color','#f3b200');
$fh_hover_background_color = et_get_option('divi_fh_button_contact_menu_hover_background_color','#f3b200');
$fh_hover_text_color = et_get_option('divi_fh_button_contact_menu_hover_text_color','#ffffff');
$fh_hover_border_color = et_get_option('divi_fh_button_contact_menu_hover_border_color','#f3b200');
$fh_border_radius = et_get_option('divi_fh_button_contact_menu_border_radius','1px');
//$fh_padding = et_get_option('divi_fh_button_contact_menu_padding','0px');

$mobile_background_color = et_get_option('divi_mobile_button_contact_menu_background_color','rgba(255,255,255,0.93)');
$mobile_text_color = et_get_option('divi_mobile_button_contact_menu_text_color','#0a0a0a');
$mobile_border_color = et_get_option('divi_mobile_button_contact_menu_border_color','#ffffff');
$mobile_border_radius = et_get_option('divi_mobile_button_contact_menu_border_radius','2px');
$mobile_border_width = et_get_option('divi_mobile_button_contact_menu_border_width','2px');

$divi_mobile_fixed_header_background = et_get_option('fixed_primary_nav_bg');
$divi_fixed_header_on_mobiles = et_get_option('divi_fixed_header_on_mobiles','on');

$mobile_nav_background_color = et_get_option('divi_marvel_mobile_nav_background_color','#f3b200');
$mobile_nav_text_color = et_get_option('divi_marvel_mobile_nav_text_color','#fff');

$divi_marvel_switch_to_mobile_menu = !empty(et_get_option('divi_marvel_switch_to_mobile_menu')) ? et_get_option('divi_marvel_switch_to_mobile_menu') : '980px';

$custom_marvel_css = '';

$custom_marvel_css .='@media only screen and ( max-width: '.$divi_marvel_switch_to_mobile_menu.' ) {
			#main-header.et-fixed-header .nav li ul,#main-header.et-fixed-header .et_mobile_menu,#main-header .mobile_nav.opened #mobile_menu {background-color: '.$mobile_nav_background_color.';}
}';
	
if ( $divi_fixed_header_on_mobiles == "on" ){

	$custom_marvel_css .='@media only screen and ( max-width: '.$divi_marvel_switch_to_mobile_menu.' ) {
			.et_non_fixed_nav.et_transparent_nav #main-header, .et_non_fixed_nav.et_transparent_nav #top-header, .et_fixed_nav #main-header, .et_fixed_nav #top-header {position: fixed !important; }
			.et_fixed_nav #main-header {position: fixed !important;}
			#main-header.et-fixed-header,.et-search-form{background-color: '.$divi_mobile_fixed_header_background.';}
	}';
	
}else{
	
	$custom_marvel_css .='@media only screen and ( max-width: '.$divi_marvel_switch_to_mobile_menu.' ) {
			.et_fixed_nav #main-header {position: absolute !important;}
	}';
}

$custom_marvel_css .= '#main-header .mobile_nav.opened ul#mobile_menu li.menu-item:not(.marvel-menu-cta) a,#main-header .mobile_nav ul#mobile_menu li.menu-item:not(.marvel-menu-cta) a{color: '.$mobile_nav_text_color.' !important; }';

$custom_marvel_css .='@media only screen and ( max-width: '.$divi_marvel_switch_to_mobile_menu.' ) {
			#top-menu-nav, #top-menu {display: none !important;}
			#et_top_search {display: none !important;}
			#et_mobile_nav_menu {display: block !important;}
			
			.et_non_fixed_nav.et_transparent_nav #main-header, .et_non_fixed_nav.et_transparent_nav #top-header, .et_fixed_nav #main-header, .et_fixed_nav #top-header {position: fixed !important; }
			.et_mobile_menu { overflow: scroll !important; }
			.et_fixed_nav #main-header {position: fixed !important;}	
			body.mobilemenuscroll{overflow:hidden !important;}
			
			.et-fixed-header .marvel-menu-cta {
				margin-top: 15px;
				max-height: 50px;
			}
			
			.et-fixed-header .marvel-menu-cta a, .et-fixed-header #top-menu .marvel-menu-cta a {
				padding:0px; border-bottom: medium none;text-align:center;
			}
			.et-fixed-header .marvel-menu-cta a:hover, .et-fixed-header #top-menu .marvel-menu-cta a:hover {
				background: rgba(0, 0, 0, 0) none repeat scroll 0 0;
			}
			.marvel-menu-cta{margin-top: 15px; max-height: 50px;}
			.marvel-menu-cta a,#top-menu .marvel-menu-cta a {
				padding:0px !important; border-bottom: medium none !important;text-align:center;
			}
			.marvel-menu-cta a:hover,#top-menu .marvel-menu-cta a:hover {
				background: rgba(0, 0, 0, 0) none repeat scroll 0 0 !important;
			}
			
			.mobile_nav.opened .mobile_menu_bar::before {
				z-index: 9999;
			}
	}';
	
if ( $divi_marvel_button_size == "Small"){
	$custom_marvel_css .= 'li.marvel-menu-cta {padding: 10px 12px !important;max-height: 36px;}
							li.marvel-menu-cta:hover {padding: 10px 12px !important;max-height: 36px;}
							.et-fixed-header li.marvel-menu-cta {padding: 10px 12px !important;max-height: 36px;}
							.et-fixed-header li.marvel-menu-cta:hover {padding: 10px 12px !important;max-height: 36px;}
							@media only screen and ( max-width: '.$divi_marvel_switch_to_mobile_menu.' ) {
								li.marvel-menu-cta {padding: 5px 12px !important;max-height: 36px;}
								li.marvel-menu-cta:hover {padding: 5px 12px !important;max-height: 36px;}
								.et-fixed-header li.marvel-menu-cta {padding: 5px 12px !important;max-height: 36px;}
								.et-fixed-header li.marvel-menu-cta:hover {padding: 5px 12px !important;max-height: 36px;}
							}';			
}			
if ( $divi_marvel_button_size == "Regular"){
	$custom_marvel_css .= 'li.marvel-menu-cta {padding: 12px 20px  !important;}
							li.marvel-menu-cta:hover {padding: 12px 20px  !important;}
							.et-fixed-header li.marvel-menu-cta {padding: 12px 20px  !important;}
							.et-fixed-header li.marvel-menu-cta:hover {padding: 12px 20px  !important;}
							@media only screen and ( max-width: '.$divi_marvel_switch_to_mobile_menu.' ) {
								li.marvel-menu-cta {padding: 8px 12px !important;max-height: 42px;}
								li.marvel-menu-cta:hover {padding: 8px 12px !important;max-height: 42px;}
								.et-fixed-header li.marvel-menu-cta {padding: 8px 12px !important;max-height: 42px;}
								.et-fixed-header li.marvel-menu-cta:hover {padding: 8px 12px !important;max-height: 42px;}
							}';			
}
if ( $divi_marvel_button_size == "Large"){
	$custom_marvel_css .='li.marvel-menu-cta {padding: 25px !important;}
							li.marvel-menu-cta:hover {padding: 25px !important;}
							.et-fixed-header li.marvel-menu-cta {padding: 25px !important;}
							.et-fixed-header li.marvel-menu-cta:hover {padding: 25px !important;}
							.nav li.marvel-menu-cta { line-height: 0em;margin-bottom: 15px;}
							.et_header_style_left #et-top-navigation nav > ul > li > a, .et_header_style_split #et-top-navigation nav > ul > li > a {padding-bottom: 34px;}
							@media only screen and ( max-width: '.$divi_marvel_switch_to_mobile_menu.' ) {
								li.marvel-menu-cta {padding: 12px 25px !important;}
								li.marvel-menu-cta:hover {padding: 12px 25px !important;}
								.et-fixed-header li.marvel-menu-cta {padding: 12px 25px !important;}
								.et-fixed-header li.marvel-menu-cta:hover {padding: 12px 25px !important;}
							}';			
}

$custom_marvel_css .= 'li.marvel-menu-cta {
						background-color: '.$dh_background_color.';
						border: 1px solid '.$dh_border_color.';
						border-radius : '.$dh_border_radius.';
					 }
					 li.marvel-menu-cta:hover {
						background-color: '.$dh_hover_background_color.';
						border: 1px solid '.$dh_hover_border_color.';
						border-radius : '.$dh_border_radius.';
					}
					.marvel-menu-cta a,#top-menu .marvel-menu-cta a{color:'.$dh_text_color.';}
					.marvel-menu-cta a:hover,#top-menu .marvel-menu-cta a:hover{color:'.$dh_hover_text_color.';}
					
					.et-fixed-header li.marvel-menu-cta {
						background-color: '.$fh_background_color.';
						border: 1px solid '.$fh_border_color.';
						border-radius : '.$fh_border_radius.';
					 }
					 .et-fixed-header li.marvel-menu-cta:hover {
						background-color: '.$fh_hover_background_color.';
						border: 1px solid '.$fh_hover_border_color.';
						border-radius : '.$fh_border_radius.';
					}.
					
					.et-fixed-header .marvel-menu-cta a,.et-fixed-header #top-menu .marvel-menu-cta a{color:'.$fh_text_color.' !important;}
					.et-fixed-header .marvel-menu-cta a:hover,.et-fixed-header #top-menu .marvel-menu-cta a:hover{color:'.$fh_hover_text_color.' !important;}
					.et-fixed-header #top-menu li.marvel-menu-cta > a, .et-fixed-header #top-menu li.marvel-menu-cta > a{color:'.$fh_hover_text_color.' !important;}
					
					@media only screen and ( max-width: '.$divi_marvel_switch_to_mobile_menu.' ) {
						
						#et_mobile_nav_menu #mobile_menu li.marvel-menu-cta,#et_mobile_nav_menu #mobile_menu li.marvel-menu-cta:hover {
							background-color: '.$mobile_background_color.';
							border: '.$mobile_border_width.' solid '.$mobile_border_color.';
							border-radius : '.$mobile_border_radius.';
							margin-bottom: 60px;
						 }
						#et_mobile_nav_menu #mobile_menu .marvel-menu-cta a{color:'.$mobile_text_color.';}
						#et_mobile_nav_menu #mobile_menu .marvel-menu-cta a:hover{color:'.$mobile_text_color.';}
						.et-fixed-header #et_mobile_nav_menu #mobile_menu .marvel-menu-cta a,.et-fixed-header #et_mobile_nav_menu #mobile_menu .marvel-menu-cta a{color:'.$mobile_text_color.' !important;}
						.et-fixed-header #et_mobile_nav_menu #mobile_menu .marvel-menu-cta a:hover,.et-fixed-header #et_mobile_nav_menu #mobile_menu .marvel-menu-cta a:hover{color:'.$mobile_text_color.' !important;}
						  .et-fixed-header #et_mobile_nav_menu #mobile_menu li.marvel-menu-cta > a, .et-fixed-header #et_mobile_nav_menu #mobile_menu li.marvel-menu-cta > a{color:'.$mobile_text_color.' !important;}
					}
				  ';
				         
wp_add_inline_style( 'marvel_custom_button', $custom_marvel_css );


 // Add custom default color
$select_default_color = et_get_option('divi_mobile_select_default_color','#f7af11');
$active_default_color = et_get_option('divi_mobile_active_default_color','#ffffff');

$marvel_select_type = et_get_option('divi_marvel_select_type','1');
$marvel_select_style = et_get_option('divi_marvel_select_style','1');


$default_color_selector = ( '2' === $marvel_select_type || '3' === $marvel_select_type ) ?
'body.et_divi_100_custom_hamburger_menu .et_divi_100_custom_hamburger_menu__icon div:before,
body.et_divi_100_custom_hamburger_menu .et_divi_100_custom_hamburger_menu__icon div:after' :
'body.et_divi_100_custom_hamburger_menu .et_divi_100_custom_hamburger_menu__icon div';

if ( $select_default_color != '' ) {
	$custom_default_color_css = sprintf(
		'%1$s {
			background: %2$s;
		}',
		$default_color_selector,
		$select_default_color
	);
	wp_add_inline_style( 'marvel_custom_button', $custom_default_color_css );
}

// Add custom active color
$active_color_selector = ( '2' === $marvel_select_type || '3' === $marvel_select_type ) ?
'body.et_divi_100_custom_hamburger_menu .et_divi_100_custom_hamburger_menu__icon.et_divi_100_custom_hamburger_menu__icon--toggled div:before,
body.et_divi_100_custom_hamburger_menu .et_divi_100_custom_hamburger_menu__icon.et_divi_100_custom_hamburger_menu__icon--toggled div:after' :
'body.et_divi_100_custom_hamburger_menu .et_divi_100_custom_hamburger_menu__icon.et_divi_100_custom_hamburger_menu__icon--toggled div';

if ( $active_default_color != '' ) {
	$custom_active_color_css = sprintf(
		'%1$s {
			background: %2$s;
		}',
		$active_color_selector,
		$active_default_color
	);
	wp_add_inline_style( 'marvel_custom_button', $custom_active_color_css );
}

}

function marvel_divi_child_theme_setup() {

	if ( ! class_exists('ET_Builder_Module') ) {
		return;
	}
    require_once( get_stylesheet_directory() . '/marvel_portfolio.php' );
	require_once( get_stylesheet_directory() . '/marvel_search.php' );
	
	$marvel_portfolio_module = new marvel_ET_Builder_Module_Filterable_Portfolio();
	$marvel_saerch_module = new marvel_ET_Builder_Module_Search();
 
	remove_shortcode( 'et_pb_filterable_portfolio' );
	remove_shortcode( 'et_pb_search' );
 
	add_shortcode( 'et_pb_filterable_portfolio', array($marvel_portfolio_module, '_shortcode_callback') );
	add_shortcode( 'et_pb_search', array($marvel_saerch_module, '_shortcode_callback') );
	
	
 
}
 
add_action( 'wp', 'marvel_divi_child_theme_setup', 9999 );

function marvel_et_pb_portfolio_image_width () {return 335;} //define your own width value
function marvel_et_pb_portfolio_image_height () {return 335;} //define your own height value
 
//add_filter('et_pb_portfolio_image_width', 'marvel_et_pb_portfolio_image_width');
//add_filter('et_pb_portfolio_image_height', 'marvel_et_pb_portfolio_image_height');

// Expanding bar
require_once( get_stylesheet_directory() . '/b3_expanding_bar_module.php' );

/* Convert hexdec color string to rgb(a) string
$color = '#ffa226';
$rgb = hex2rgba($color);
$rgba = hex2rgba($color, 0.7);
*/
 
function marvel_hex2rgba($color, $opacity = false) {
 
	$default = 'rgb(0,0,0)';
 
	//Return default if no color provided
	if(empty($color))
          return $default; 
 
	//Sanitize $color if "#" is provided 
        if ($color[0] == '#' ) {
        	$color = substr( $color, 1 );
        }
 
        //Check if color has 6 or 3 characters and get values
        if (strlen($color) == 6) {
                $hex = array( $color[0] . $color[1], $color[2] . $color[3], $color[4] . $color[5] );
        } elseif ( strlen( $color ) == 3 ) {
                $hex = array( $color[0] . $color[0], $color[1] . $color[1], $color[2] . $color[2] );
        } else {
                return $default;
        }
 
        //Convert hexadec to rgb
        $rgb =  array_map('hexdec', $hex);
 
        //Check if opacity is set(rgba or rgb)
        if($opacity){
        	if(abs($opacity) > 1)
        		$opacity = 1.0;
        	$output = 'rgba('.implode(",",$rgb).','.$opacity.')';
        } else {
        	$output = 'rgb('.implode(",",$rgb).')';
        }
 
        //Return rgb(a) color string
        return $output;
}

add_filter('body_class','b3_marvel_class');
function b3_marvel_class($classes) {
  if ( is_single() || is_tag() || is_category() || is_author() || is_archive() || is_date() || is_day() || is_month() || is_tax() || is_time() || is_year() ||  is_search() ) {
    	 $classes[] = 'marvel_sidebar';
  }
  return $classes;
}

if ( ! function_exists( 'et_pb_postinfo_meta' ) ) :
function et_pb_postinfo_meta( $postinfo, $date_format, $comment_zero, $comment_one, $comment_more ){
	$postinfo_meta = '';

	if ( !is_category() ){
		if ( in_array( 'author', $postinfo ) )
			$postinfo_meta .= ' ' . esc_html__( 'by', 'et_builder' ) . ' <span class="author vcard">' . et_pb_get_the_author_posts_link() . '</span>';
	
		if ( in_array( 'date', $postinfo ) ) {
			if ( in_array( 'author', $postinfo ) ) $postinfo_meta .= ' | ';
			$postinfo_meta .= '<span class="published">' . esc_html( get_the_time( wp_unslash( $date_format ) ) ) . '</span>';
		}
	}
	if ( in_array( 'categories', $postinfo ) ) {
		$categories_list = get_the_category_list(' '); if ( !is_category() ){ $categories_list = get_the_category_list(', ');}

		// do not output anything if no categories retrieved
		if ( '' !== $categories_list ) {
			if ( !is_category() ){ if ( in_array( 'author', $postinfo ) || in_array( 'date', $postinfo ) )	$postinfo_meta .= ' | '; }

			$postinfo_meta .= $categories_list;
		}
	}

	if ( in_array( 'comments', $postinfo ) ){
		if ( in_array( 'author', $postinfo ) || in_array( 'date', $postinfo ) || in_array( 'categories', $postinfo ) ) $postinfo_meta .= ' | ';
		$postinfo_meta .= et_pb_get_comments_popup_link( $comment_zero, $comment_one, $comment_more );
	}

	return $postinfo_meta;
}
endif;



function b3_marvel_myfont_icons($icons) {
    $icons[] = '&#xe1900;';  $icons[] = '&#xe1901;';  $icons[] = '&#xe1902;'; $icons[] = '&#xe1903;'; $icons[] = '&#xe1904;'; $icons[] = '&#xe1905;';
	$icons[] = '&#xe1906;';  $icons[] = '&#xe1907;';  $icons[] = '&#xe1908;'; $icons[] = '&#xe1909;'; $icons[] = '&#xe190a;'; $icons[] = '&#xe190b;';
	$icons[] = '&#xe190c;';  $icons[] = '&#xe190d;';  $icons[] = '&#xe190e;'; $icons[] = '&#xe190f;'; $icons[] = '&#xe1910;'; $icons[] = '&#xe1911;';
	$icons[] = '&#xe1912;';  $icons[] = '&#xe1913;';  $icons[] = '&#xe1914;'; $icons[] = '&#xe1915;'; $icons[] = '&#xe1916;'; $icons[] = '&#xe1917;';
	$icons[] = '&#xe1918;';  $icons[] = '&#xe1919;';  $icons[] = '&#xe191a;'; $icons[] = '&#xe191b;'; $icons[] = '&#xe191c;'; $icons[] = '&#xe191d;';
	$icons[] = '&#xe191e;';  $icons[] = '&#xe191f;';  $icons[] = '&#xe1920;'; $icons[] = '&#xe1921;'; $icons[] = '&#xe1922;'; $icons[] = '&#xe1923;';
	$icons[] = '&#xe1924;';  $icons[] = '&#xe1925;';  $icons[] = '&#xe1926;'; $icons[] = '&#xe1927;'; $icons[] = '&#xe1928;'; $icons[] = '&#xe1929;';
	$icons[] = '&#xe192a;';  $icons[] = '&#xe192b;';  $icons[] = '&#xe192c;'; $icons[] = '&#xe192d;'; $icons[] = '&#xe192e;'; $icons[] = '&#xe192f;';
	$icons[] = '&#xe1930;';  $icons[] = '&#xe1931;';  $icons[] = '&#xe1932;'; $icons[] = '&#xe1933;'; $icons[] = '&#xe1934;'; $icons[] = '&#xe1935;';
	$icons[] = '&#xe1936;';  $icons[] = '&#xe1937;';  $icons[] = '&#xe1938;'; $icons[] = '&#xe1939;'; $icons[] = '&#xe193a;'; $icons[] = '&#xe193b;';
	$icons[] = '&#xe193c;';  $icons[] = '&#xe193d;';  $icons[] = '&#xe193e;'; $icons[] = '&#xe193f;'; $icons[] = '&#xe1940;'; $icons[] = '&#xe1941;';
	$icons[] = '&#xe1942;';  $icons[] = '&#xe1943;';  $icons[] = '&#xe1944;'; $icons[] = '&#xe1945;'; $icons[] = '&#xe1946;'; $icons[] = '&#xe1947;';
	$icons[] = '&#xe1948;';  $icons[] = '&#xe1949;';  $icons[] = '&#xe194a;'; $icons[] = '&#xe194b;'; $icons[] = '&#xe194c;'; $icons[] = '&#xe194d;';
	$icons[] = '&#xe194e;';  $icons[] = '&#xe194f;';  $icons[] = '&#xe1950;'; $icons[] = '&#xe1951;'; $icons[] = '&#xe1952;'; $icons[] = '&#xe1953;';
	$icons[] = '&#xe1954;';  $icons[] = '&#xe1955;';  $icons[] = '&#xe1956;'; $icons[] = '&#xe1957;'; $icons[] = '&#xe1958;'; $icons[] = '&#xe1959;';
	$icons[] = '&#xe195a;';  $icons[] = '&#xe195b;';  $icons[] = '&#xe195c;'; $icons[] = '&#xe195d;'; $icons[] = '&#xe195e;'; $icons[] = '&#xe195f;';
	$icons[] = '&#xe1960;';  $icons[] = '&#xe1961;';  $icons[] = '&#xe1962;'; $icons[] = '&#xe1963;'; $icons[] = '&#xe1964;'; $icons[] = '&#xe1965;';
	$icons[] = '&#xe1966;';  $icons[] = '&#xe1967;';  $icons[] = '&#xe1968;'; $icons[] = '&#xe1969;'; $icons[] = '&#xe196a;'; $icons[] = '&#xe196c;';
	$icons[] = '&#xe196d;';  $icons[] = '&#xe196e;';  $icons[] = '&#xe196f;'; $icons[] = '&#xe1970;'; $icons[] = '&#xe1971;'; $icons[] = '&#xe1972;';
	$icons[] = '&#xe196b;'; 
	 
    return $icons;
}
add_filter('et_pb_font_icon_symbols', 'b3_marvel_myfont_icons');

add_filter( 'body_class','b3_marvel_body_class'  );

function b3_marvel_body_class( $classes ) {
	
	$marvel_select_type = et_get_option('divi_marvel_select_type','1');
	$marvel_select_style = et_get_option('divi_marvel_select_style','1');


	$classes[] = 'et_divi_100_custom_hamburger_menu et_divi_100_custom_hamburger_menu--style-'.$marvel_select_style.' et_divi_100_custom_hamburger_menu--type-'.$marvel_select_type;
	
	if ( is_404() ) 
	{
		 $divi_404page_layout = et_get_option('divi_404page_layout');
		 if ( $divi_404page_layout!= '' ){
			$classes[] = 'et_full_width_page';
			if (in_array('et_pb_pagebuilder_layout', $classes)) {			
					 unset( $classes[array_search('et_right_sidebar', $classes)] );
					 unset( $classes[array_search('et_pb_pagebuilder_layout', $classes)] );
			}
		}

	}
	
	return $classes;
}
?>